/*
	Disk IO and path parsing
*/


#ifndef DISK_H
#define DISK_H

extern int FILEHASEXTENSION(char *filename);
extern int ISPATHABSOLUTE(char *path);
extern int ISPATHTOPLEVEL(char *path);
extern int NUMDIRCONTENTS(char *path);

extern int ISDESCRWRITEABLE(int fd);
extern int ISDESCRREADABLE(int fd);

extern int COMPARE_PARENT_PATHS(char *path, char *parent);

extern int ISPATHDIR(char *path);
extern int ISLPATHDIR(char *path);
extern int ISPATHEXECUTABLE(char *path);

extern char *PathSubHome(char *path);
extern char **GetDirEntNames(char *parent);
extern char *ChangeDirRel(char *cpath, char *npath);
extern void StripAbsolutePath(char *path);
extern char *PrefixPaths(char *parent, char *child);
extern char *GetAllocLinkDest(char *link);
extern char *GetParent(char *path);

extern int FileCountLines(char *filename);
extern int DirHasSubDirs(char *path);
extern void SimplifyPath(char *path);

extern int CopyObject(
	char *target,
	char *source,
	int (*comferm_func)(char *, char *)
);



#endif /* DISK_H */
