/*
	Audio format library wrapper
 */

#ifndef AFW_H
#define AFW_H

#include "ytypes.h"
#include "raw.h"
#include "wav.h"
#include "voc.h"


/*
 *	Audio format codes:
 */
#define FileFormatUnknown	0
#define FileFormatRaw		1
#define FileFormatWav		2
#define FileFormatVoc		3
#define FileFormatMP3		4


/*
 *	Audio format wrapper data structure:
 */
typedef struct {

	/* Pointer to allocated native audio library data struct. */
	void *ptr;

	/*   Format, determines pointer type of member ptr.
	 *   Can be any of FileFormat*
	 */
	int format;

	/* Entire length of audio data in file. */
	YDataLength entire_length;

	/* Buffer. */
	char *buffer;
	YDataLength length;

	/* Block align and length. */
	YDataPosition block_align;
	YDataLength block_length;

} AFWDataStruct;



extern int AFWOpen(char *path, AFWDataStruct *af_data);

extern int AFWLoadSegment(
	AFWDataStruct *af_data,
	YDataPosition position,
	YDataLength length
);

extern void AFWClose(AFWDataStruct *af_data);


#endif	/* AFW_H */
