#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>


#include "../include/strexp.h"
#include "../include/string.h"

#include "yhost.h"



int YHostIsAllocated(int n)
{
        if((n < 0) ||
           (n >= total_yhosts) ||
           (yhost == NULL)
        )
            return(0);
        else if(yhost[n] == NULL)
            return(0);
        else
            return(1);
}


YHost *YHostGetPtr(int n)
{
        if(YHostIsAllocated(n))
            return(yhost[n]);
        else
            return(NULL);
}


int YHostInList(char *host)
{
	int i;
	int strc;
	char **strv;
	unsigned char c[4];
	YHost **ptr;


	if(host == NULL)
	    return(0);


	strv = strchrexp(host, '.', &strc);
	if((strv == NULL) || (strc < 4))
	{
	    StringFreeArray(strv, strc);
	    return(0);
	}

	c[0] = atoi(strv[0]);
        c[1] = atoi(strv[1]);
        c[2] = atoi(strv[2]);
        c[3] = atoi(strv[3]);

	StringFreeArray(strv, strc);


	for(i = 0, ptr = yhost;
            i < total_yhosts;
            i++, ptr++
	)
	{
	    if(*ptr == NULL)
		continue;

	    if((c[0] == (*ptr)->c[0]) &&
               (c[1] == (*ptr)->c[1]) &&
               (c[2] == (*ptr)->c[2]) &&
               (c[3] == (*ptr)->c[3])
	    )
		return(1);
	}

	return(0);
}



void YHostDeleteByHost(char *host)
{
        int i, strc;
        char **strv;
        unsigned char c[4];
        YHost **ptr;


	if(host == NULL)
	    return;

        strv = strchrexp(host, '.', &strc);
        if((strv == NULL) || (strc < 4))
        {
            StringFreeArray(strv, strc);
            return;
        }

        c[0] = atoi(strv[0]);
        c[1] = atoi(strv[1]);
        c[2] = atoi(strv[2]);
        c[3] = atoi(strv[3]);

        StringFreeArray(strv, strc);


        for(i = 0, ptr = yhost;
            i < total_yhosts;
            i++, ptr++
        )
        {
            if(*ptr == NULL)
                continue;
        
            if((c[0] == (*ptr)->c[0]) &&
               (c[1] == (*ptr)->c[1]) &&
               (c[2] == (*ptr)->c[2]) &&
               (c[3] == (*ptr)->c[3])
            )
	    {
		YHostDelete(i);
	    }
        }


	return;
}


int YHostAllocate(char *host)
{
        int i, n;
	int strc;
	char **strv;


        for(i = 0; i < total_yhosts; i++)
        {
            if(yhost[i] == NULL) 
                break;
        }
        if(i < total_yhosts)
        {
            n = i;
        }
        else
        {
            n = total_yhosts;
            total_yhosts++;

            yhost = (YHost **)realloc(
                yhost,
                total_yhosts * sizeof(YHost *)
            );
            if(yhost == NULL)
            {
                total_yhosts = 0;
                return(-1);
            }
        }

        yhost[n] = (YHost *)calloc(1,
            sizeof(YHost)
        );
        if(yhost[n] == NULL)
        {
            return(-1);
        }       


        /* Reset values. */
	if(host != NULL)
	{
            yhost[n]->host = StringCopyAlloc(host);

	    strv = strchrexp(host, '.', &strc);
	    if((strv != NULL) && (strc >= 4))
	    {
                yhost[n]->c[0] = atoi(strv[0]);
                yhost[n]->c[1] = atoi(strv[1]);
                yhost[n]->c[2] = atoi(strv[2]);
                yhost[n]->c[3] = atoi(strv[3]);
	    }

	    StringFreeArray(strv, strc);
	}


        return(n);
}


void YHostDelete(int n)
{
        if(YHostIsAllocated(n))
        {
            /* Free allocated substructures. */
            free(yhost[n]->host);

            /* Free structure itself. */
            free(yhost[n]);
            yhost[n] = NULL;
        }

        return;
}


void YHostDeleteAll()
{
        int i;

        for(i = 0; i < total_yhosts; i++)
        {
            YHostDelete(i);
        }

        free(yhost);   
        yhost = NULL;

        total_yhosts = 0;

        return;
}
