#ifndef YTYPES_H
#define YTYPES_H


#include <stdio.h>
#include <db.h>
#include <sys/types.h>


#ifdef __linux__
# include <linux/limits.h>
#endif	/* __linux__ */



/* NULL pointer for YID. */
#define YIDNULL	0


/* Boolean values. */
#define False	0
#define True	1


/* Path and filename maximums. */
#ifndef PATH_MAX
# define PATH_MAX	1024
#endif

#ifndef NAME_MAX
# define NAME_MAX	256
#endif




/*
 *	General:
 *
 *	Note: YID's of different types may share the same value.
 */
typedef char Boolean;
typedef unsigned long YID;

/*
 *	Data byte units:
 */
typedef long YDataPosition;
typedef long YDataLength;

/*
 *	Sound buffer type:
 */
typedef char SoundBuffer;

/*
 *	Permissions:
 */
typedef int AccessLevel;
typedef unsigned short YPermission;

/*
 *	Client connection number type:
 */
typedef int YConnectionNumber;

/*
 *	Play stack ID type:
 */
typedef YID PlayStackID;
 


/*
 *	Scientific units:
 */
typedef double Coefficient;



#endif	/* YTYPES_H */
